## Section: New Results

### Graph Algorithms

Participants : Julien Bensmail, Nathann Cohen, David Coudert, Guillaume Ducoffe, Valentin Garnero, Frédéric Giroire, Frédéric Havet, Fionn Mc Inerney, Nicolas Nisse, Stéphane Pérennes, Rémi Watrigant.

Coati is interested in the algorithmic aspects of Graph Theory. In general we try to find the most efficient algorithms to solve various problems of Graph Theory and telecommunication networks. We use Graph Theory to model various network problems. We study their complexity and then we investigate the structural properties of graphs that make these problems hard or easy.

#### Complexity of graph problems

We also investigate several graph problems coming from various applications. We mainly consider their complexity in general or particular graph classes. When possible, we present polynomial-time (approximation) algorithms or Fixed Parameter Tractable algorithms.

##### Parameterized complexity of polynomial optimization problems (FPT in P)

Parameterized complexity theory has enabled a refined classification of the difficulty of NP-hard optimization problems on graphs with respect to key structural properties, and so to a better understanding of their true difficulties. More recently, hardness results for problems in P were established under reasonable complexity theoretic assumptions such as: Strong Exponential Time Hypothesis (SETH), 3SUM and All-Pairs Shortest-Paths (APSP). According to these assumptions, many graph theoretic problems do not admit truly subquadratic algorithms, nor even truly subcubic algorithms (Williams and Williams, FOCS 2010 [82] and Abboud *et al.* SODA 2015 [70]). A central technique used to tackle the difficulty of the above mentioned problems is fixed-parameter algorithms for polynomial-time problems with *polynomial dependency* in the fixed parameter (P-FPT). This technique was rigorously formalized by Giannopoulou et al. (IPEC 2015) [75], [76]. Following that, it was continued by Abboud *et al.* (SODA 2016) [71], by Husfeldt (IPEC 2016) [78] and Fomin *et al.* (SODA 2017) [74], using the treewidth as a parameter. Applying this technique to *clique-width*, another important graph parameter, remained to be done.

In [55] we study several graph theoretic problems for which hardness results exist such as *cycle problems* (triangle detection, triangle counting, girth), *distance problems* (diameter, eccentricities, Gromov hyperbolicity, betweenness centrality) and *maximum matching*. We provide hardness results and fully polynomial FPT algorithms, using clique-width and some of its upper-bounds as parameters (split-width, modular-width and ${P}_{4}$-sparseness). We believe that our most important result is an $\mathcal{O}({k}^{4}\xb7n+m)$-time algorithm for computing a maximum matching where $k$ is either the modular-width or the ${P}_{4}$-sparseness. The latter generalizes many algorithms that have been introduced so far for specific subclasses such as cographs, ${P}_{4}$-lite graphs, ${P}_{4}$-extendible graphs and ${P}_{4}$-tidy graphs.
Our algorithms are based on preprocessing methods using modular decomposition, split decomposition and primeval decomposition. Thus they can also be generalized to some graph classes with unbounded clique-width.

##### Finding cut-vertices in the square roots of a graph

The square of a given graph $H=(V,E)$ is obtained from $H$ by adding an edge between every two vertices at distance two in $H$. Given a graph class $\mathscr{H}$, the ℋ-Square Root problem asks for the recognition of the squares of graphs in $\mathscr{H}$.
In [56], [46], we answer positively to an open question of Golovach *et al.* (IWOCA'16) [77] by showing that the squares of *cactus-block graphs* can be recognized in polynomial time. Our proof is based on new relationships between the decomposition of a graph by cut-vertices and the decomposition of its square by clique cutsets.
More precisely, we prove that the closed neighbourhoods of cut-vertices in $H$ induce maximal subgraphs of $G={H}^{2}$ with no clique-cutset. Furthermore, based on this relationship, we can compute from a given graph $G$ the block-cut tree of a desired square root (if any). Although the latter tree is not uniquely defined, we show surprisingly that it can only differ marginally between two different roots. Our approach not only gives the first polynomial-time algorithm for the ℋ-Square Root problem for several graph classes $\mathscr{H}$, but it also provides a unifying framework for the recognition of the squares of trees, block graphs and cactus graphs — among others.

##### Graph hyperbolicity

The Gromov hyperbolicity is an important parameter for analyzing complex networks which expresses how the metric structure of a network looks like a tree (the smaller gap the better). It has recently been used to provide bounds on the expected stretch of greedy-routing algorithms in Internet-like graphs, and for various applications in network security, computational biology, the analysis of graph algorithms, and the classification of complex networks.

In [44], we answer open questions of Verbeek and Suri [81] on the relationships between Gromov hyperbolicity and the optimal stretch of graph embeddings in Hyperbolic space. Then, based on the relationships between hyperbolicity and Cops and Robber games, we turn necessary conditions for a graph to be Cop-win into sufficient conditions for a graph to have a large hyperbolicity (and so, no low-stretch embedding in Hyperbolic space). In doing so we derive lower-bounds on the hyperbolicity in various graph classes – such as Cayley graphs, distance-regular graphs and generalized polygons, to name a few. It partly fills in a gap in the literature on Gromov hyperbolicity, for which few lower-bound techniques are known.

In [23] we study practical improvements for the computation of hyperbolicity in large graphs. Precisely, we investigate relations between the hyperbolicity of a graph $G$ and the hyperbolicity of its *atoms*, that are the subgraphs output by the clique-decomposition invented by Tarjan [80] and Leimer [79]. We prove that the maximum hyperbolicity taken over the atoms is at most one unit off from the hyperbolicity of $G$ and the bound is sharp. We also give an algorithm to slightly modify the atoms, called the "substitution method", which is at no extra cost than computing the clique-decomposition, and so that the maximum hyperbolicity taken over the resulting graphs is *exactly* the hyperbolicity of the input graph $G$. Experimental evaluation on collaboration networks and biological networks shows that our method provides significant computation time savings. Finally, on a more theoretical side, we deduce from our results the first *linear-time* algorithm for computing the hyperbolicity of an outerplanar graph.

##### Computing metric hulls in graphs

Convexity in graphs generalises the classical convexity in Euclidean spaces. The *hull-number* of a graph is the minimum number k such that there exists a set of k vertices whose convex hull is the graph. Computing the hull-number is NP-hard even in very restricted graph classes such as partial cubes (isometric subgraphs of hypercubes). One challenging question in this area is the status of the parameterized complexity of this problem. We further investigate the complexity of a more general problem.

In [60], we prove that, given a closure function the smallest preimage of a closed set can be calculated in polynomial time in the number of closed sets. This confirms a conjecture of Albenque and Knauer and implies that there is a polynomial time algorithm to compute the convex hull-number of a graph, when all its convex subgraphs are given as input. We then show that computing if the smallest preimage of a closed set is logarithmic in the size of the ground set is LOGSNP-complete if only the ground set is given. A special instance of this problem is computing the dimension of a poset given its linear extension graph, that was conjectured to be in P.

The intent to show that the latter problem is LOGSNP-complete leads to several interesting questions and to the definition of the isometric hull, i.e., a smallest isometric subgraph containing a given set of vertices $S$. While for $\left|S\right|=2$ an isometric hull is just a shortest path, we show that computing the isometric hull of a set of vertices is NP-complete even if $\left|S\right|=3$. Finally, we consider the problem of computing the isometric hull-number of a graph and show that computing it is ${\Sigma}_{2}^{P}$-complete.

##### Application to bioinformatics

For a (possibly infinite) fixed family of graphs $F$, we say that a graph $G$ overlays $F$ on a hypergraph $H$ if $V\left(H\right)$ is equal to $V\left(G\right)$ and the subgraph of $G$ induced by every hyperedge of $H$ contains some member of $F$ as a spanning subgraph. While it is easy to see that the complete graph on $\left|V\right(H\left)\right|$ overlays $F$ on a hypergraph $H$ whenever the problem admits a solution, the Minimum $F$-Overlay problem asks for such a graph with the minimum number of edges. This problem allows to generalize some natural problems which may arise in practice. For instance, if the family $F$ contains all connected graphs, then Minimum $F$-Overlay corresponds to the Minimum Connectivity Inference problem (also known as Subset Interconnection Design problem) introduced for the low-resolution reconstruction of macro-molecular assembly in structural biology, a problem that has been studied jointly by Coati and ABS [72], [73], or for the design of networks. In [41], we show a strong dichotomy result regarding the polynomial vs. NP-hard status with respect to the considered family $F$. Roughly speaking, we show that the easy cases one can think of (e.g. when edge-less graphs of the right sizes are in $F$, or if $F$ contains only cliques) are the only families giving rise to a polynomial problem: all others are NP-complete. We then investigate the parameterized complexity of the problem and give similar sufficient conditions on $F$ that give rise to W[1]-hard, W[2]-hard or FPT problems when the parameter is the size of the solution. This yields an FPT/W[1]-hard dichotomy for a relaxed problem, where every hyperedge of $H$ must contain some member of $F$ as a (non necessarily spanning) subgraph.

##### Matchings for the recovery of disrupted airline operations

In an informal collaboration with Amadeus' members (A. Salch and V. Weber), we have studied the following problem. When an aircraft is approaching an airport, it gets a short time interval (called *slot*) that it can use to land. If the landing of the aircraft is delayed (because of bad weather, or if it arrives late, or if other aircrafts have to land first), it looses its slot and Air traffic controllers have to assign it a new slot. However, slots for landing are a scare resource of the airports and, to avoid that an aircraft waits too much time, Air traffic controllers have to regularly modify the assignment of the slots of the aircrafts. Unfortunately, for legal and economical reasons, Air traffic controllers can modify the slot-assignment only through specific kind of operations. The problem is then the following. Precisely, let $k\ge 1$ be an odd integer, a graph $G$ and a matching $M$ (set of pairwise disjoint edges) of $G$. What is the maximum size of a matching that can be obtained from $M$ by *using* only augmenting paths of length *at most $k$*?

By Berge's theorem, finding a *maximum matching* in a graph relies on *the use* of *augmenting paths*. When no further constraint is added ($k$ unbounded), Edmonds' algorithm allows to compute a maximum matching in polynomial time by sequentially augmenting such paths.
In [39], we first prove that this problem can be solved in polynomial time for $k\le 3$ in any graph and that it is *NP*-complete for any fixed $k\ge 5$ in the class of planar bipartite graphs of degree at most 3 and arbitrarily large girth. We then prove that this problem is in *P*, for any $k$, in several subclasses of trees such as caterpillars or trees with all vertices of degree at least 3 “far appart”. Moreover, this problem can be solved in time $O\left(n\right)$ in the class of $n$-node trees when $k$ and the maximum degree are fixed parameters. Finally, we consider a more constrained problem where only paths of length *exactly* $k$ can be augmented. We prove that this latter problem becomes *NP*-complete for any fixed $k\ge 3$ and in trees when $k$ is part of the input.

In [51], we perform a deeper analysis of the complexity of this problem for trees. On the positive side, we first show that it can be solved in polynomial time for more classes of trees, namely bounded-degree trees (via a dynamic programming approach), caterpillars and trees where the nodes with degree at least 3 are sufficiently far apart. On the negative side, we show that, when only paths of length *exactly* $k$ can be augmented, the problem becomes *NP*-complete already for $k=3$, in the class of planar bipartite graphs with maximum degree 3 and arbitrary large girth. We also show that the latter problem is *NP*-complete in trees when $k$ is part of the input.

#### Graph decompositions and graph searching

It is well known that many NP-hard problems are tractable in the class of bounded treewidth graphs. In particular, tree-decompositions of graphs are an important ingredient of dynamic programming algorithms for solving such problems. This also holds for other width-parameters of graphs. Therefore, computing these widths and associated decompositions of graphs has both a theoretical and practical interest.

##### Minimum size tree-decompositions

We study in [31] the problem of computing a tree-decomposition of a graph with width at most $k$ and minimum number of bags. More precisely, we focus on the following problem: given a fixed $k\ge 1$, what is the complexity of computing a tree-decomposition of width at most $k$ with minimum number of bags in the class of graphs with treewidth at most $k$? We prove that the problem is NP-complete for any fixed $k\ge 4$ and polynomial for $k\le 2$; for $k=3$, we show that it is polynomial in the class of trees and 2-connected outerplanar graphs.

##### Exclusive Graph Searching and pathwidth.

An algorithmic interpretation of tree/path-decomposition is the well known *graph searching* problem, where a team of searchers aims at capturing an intruder in a network, modeled as a graph.
All variants of this problem assume that any node can be simultaneously occupied by several searchers. This assumption may be unrealistic, e.g., in the case of searchers modeling physical searchers, or may require each individual node to provide additional resources, e.g., in the case of searchers modeling software agents.

We thus introduce and investigate in [22] *Exclusive Graph Searching*, in which no two or more searchers can occupy the same node at the same time. As for the classical variants of graph searching, we study the minimum number of searchers required to capture the intruder. This number is called the *exclusive search number* of the considered graph.
Exclusive graph searching appears to be considerably more complex than classical graph searching, for at least two reasons: (1) it does not satisfy the *monotonicity property*, and (2) it is not *closed under minor*.
Moreover, we observe that the exclusive search number of a tree may differ exponentially from the values of classical search numbers (e.g., pathwidth).
Nevertheless, we design a polynomial-time algorithm which, given any $n$-node tree $T$, computes the exclusive search number of $T$ in time $O\left({n}^{3}\right)$. Moreover, for any integer $k$, we provide a characterization of the trees $T$ with exclusive search number at most $k$. Finally, we prove that the ratio between the exclusive search number and the pathwidth of a graph is bounded by its maximum degree.

In [32], we study the complexity of this new variant and show that there are graph classes where its complexity differs from the complexity of pathwidth. We show that the problem is NP-hard in planar graphs with maximum degree 3 and it can be solved in linear-time in the class of cographs. We also show that *monotone* Exclusive Graph Searching is NP-complete in split graphs where Pathwidth is known to be solvable in polynomial time. Moreover, we prove that monotone Exclusive Graph Searching is in P in a subclass of star-like graphs where Pathwidth is known to be NP-hard.
Hence, the computational complexities of monotone Exclusive Graph Searching and Pathwidth cannot be compared. This is the first variant of Graph Searching for which such a difference is proved.

##### Distributed Graph Searching.

We then study exclusive graph searching in a distributed setting.
Consider a set of mobile robots placed on distinct nodes of a discrete, anonymous, and bidirectional ring.
Asynchronously, each robot takes a snapshot of the ring, determining the size of the ring and which nodes are either occupied by robots or empty. Based on the observed configuration, it decides whether to move to one of its adjacent nodes or not.
In the first case, it performs the computed move, eventually.
This model of computation is known as *Look*-*Compute*-*Move*.
The computation depends on the required task. In [25], we solve both the well-known *Gathering* and *Exclusive Searching* tasks. In the former problem, all robots must simultaneously occupy the same node, eventually. In the latter problem, the aim is to clear all edges of the graph. An edge is cleared if it is traversed by a robot or if both its endpoints are occupied. We consider the *exclusive* searching where it must be ensured that two robots never occupy the same node. Moreover, since the robots are oblivious, the clearing is *perpetual*, i.e., the ring is cleared infinitely often.

In the literature, most contributions are restricted to a subset of initial configurations. Here, we design two different algorithms and provide a characterization of the initial configurations that permit the resolution of the problems under very weak assumptions. More precisely, we provide a full characterization (except for few pathological cases) of the initial configurations for which Gathering can be solved. The algorithm relies on the necessary assumption of the local-weak multiplicity detection. This means that during the Look phase a robot detects also whether the node it occupies is occupied by other robots, without acquiring the exact number.

For the exclusive searching, we characterize all (except for few pathological cases) aperiodic configurations from which the problem is feasible. We also provide some impossibility results for the case of periodic configurations.

#### Combinatorial games on graphs

We study several two-player games on graphs. Some of these games allow to model real-life applications. In the case of the Spy-game presented below, we propose a successful new approach by studying fractional relaxation of such games.

##### Localization Game on Geometric and Planar Graphs

Motivated by a localization problem in cellular networks, we introduce in [52] a model based on a pursuit graph game that resembles the famous Cops and Robbers game. It can be considered as a game theoretic variant of the *metric dimension* of a graph. Given a graph $G$ we want to localize a walking agent by checking his distance to as few vertices as possible. We provide upper bounds on the related graph invariant $\zeta \left(G\right)$, defined as the least number of cops needed to localize the robber on a graph $G$, for several classes of graphs (trees, bipartite graphs, etc). Our main result is that, surprisingly, there exists planar graphs of treewidth 2 and unbounded $\zeta \left(G\right)$. On a positive side, we prove that $\zeta \left(G\right)$ is bounded by the pathwidth of $G$. We then show that the algorithmic problem of determining $\zeta \left(G\right)$ is NP-hard in graphs with diameter at most 2. Finally, we show that at most one cop can approximate (arbitrarily close) the location of the robber in the Euclidean plane.

##### Spy-Game on graphs

We define and study the following two-player game on a graph $G$. Let $k\in {\mathbb{N}}^{*}$. A set of $k$ guards is occupying some vertices of $G$ while one spy is standing at some vertex. At each turn, first the spy may move along at most $s$ edges, where $s\in {\mathbb{N}}^{*}$ is his speed. Then, each guard may move along one edge. The spy and the guards may occupy the same vertices. The spy has to escape the surveillance of the guards, i.e., must reach a vertex at distance more than $d\in \mathbb{N}$ (a predefined distance) from every guard. Can the spy win against $k$ guards? Similarly, what is the minimum distance $d$ such that $k$ guards may ensure that at least one of them remains at distance at most $d$ from the spy? This game generalizes two well-studied games: Cops and robber games (when $s=1$) and Eternal Dominating Set (when $s$ is unbounded).

In [53], we consider the computational complexity of the problem, showing that it is NP-hard (for every speed $s$ and distance $d$) and that some variant of it is PSPACE-hard in DAGs. Then, we establish tight tradeoffs between the number of guards, the speed $s$ of the spy and the required distance $d$ when $G$ is a path or a cycle.

In order to determine the smallest number of guards necessary for this task, we analyze in [42], [43], [54] the game through a Linear Programming formulation and the *fractional strategies* it yields for the guards. We then show the equivalence of fractional and integral strategies in trees. This allows us to design a polynomial-time algorithm for computing an optimal strategy in this class of graphs.
Using duality in Linear Programming, we also provide non-trivial bounds on the fractional guard-number of grids and torus. We believe that the approach using fractional relaxation and Linear Programming is promising to obtain new results in the field of combinatorial games.

##### Hyperopic Cops and Robbers

We introduce in [68] a new variant of the game of Cops and Robbers played on graphs, where the robber is invisible when located in the neighbor set of a cop. The hyperopic cop number is the corresponding analogue of the cop number, and we investigate bounds and other properties of this parameter. We characterize the cop-win graphs for this variant, along with graphs with the largest possible hyperopic cop number. We analyze the cases of graphs with diameter 2 or at least 3, focusing on when the hyperopic cop number is at most one greater than the cop number. We show that for planar graphs, as with the usual cop number, the hyperopic cop number is at most 3. The hyperopic cop number is considered for countable graphs, and it is shown that for connected chains of graphs, the hyperopic cop density can be any real number in $[0,1/2]$.